//
//  Shader.fsh
//  gltest00
//
//  Created by Nakahashi Teruyuki on 13/02/15.
//

varying highp vec2 v_texCoord;
//varying lowp vec2 v_texCoord;
/*
varying highp vec4 v_color;
 */
varying mediump vec4 v_color;

varying highp vec4 v_position;

/*
uniform sampler2D renderframe;
uniform sampler2D renderframe2;
 */
uniform lowp sampler2D renderframe;
uniform lowp sampler2D renderframe2;


uniform int use_alpha;
uniform int use_color;

/*
uniform highp float alpha_value;
 */
uniform mediump float alpha_value;

//uniform highp float color_table_r[256];
//uniform highp float color_table_g[256];
//uniform highp float color_table_b[256];


void main()
{
    /*
    highp vec4 col1;
    highp vec4 col2;
    highp vec4 col3;
    */
    mediump vec4 col1;
    mediump vec4 col2;
    mediump vec4 col3;

    
    col1 = texture2D(renderframe2, v_position.xy);
    col2 = texture2D(renderframe, v_texCoord);
    if (use_alpha != 0) {
        col2.a = col2.a * alpha_value;
    }
    if (use_color != 0) {
        col2 = col2 * v_color;
    }
    
    col3 = col2;
    
    /*
    highp float rat = 0.82;
     */
    mediump float rat = 0.82;
    
    /*
    highp float gray;
     */
    //lowp float gray;
    
    /*
    gray = col2.r;
    if (gray >= 0.5) {
        col3.r = (1.0 - (1.0 - 2.0 * (gray - 0.5)) * (1.0 - col1.r)) * rat + (1.0 - rat) * col2.r;
    } else {
        col3.r = 2.0 * gray * col1.r * rat + (1.0 - rat) * col2.r;
    }
    gray = col2.g;
    if (gray >= 0.5) {
        col3.g = (1.0 - (1.0 - 2.0 * (gray - 0.5)) * (1.0 - col1.g)) * rat + (1.0 - rat) * col2.g;
    } else {
        col3.g = 2.0 * gray * col1.g * rat + (1.0 - rat) * col2.b;
    }
    gray = col2.b;
    if (gray >= 0.5) {
        col3.b = (1.0 - (1.0 - 2.0 * (gray - 0.5)) * (1.0 - col1.b)) * rat + (1.0 - rat) * col2.b;
    } else {
        col3.b = 2.0 * gray * col1.b * rat + (1.0 - rat) * col2.b;
    }
     */
    mediump float g;
    mediump float g0;
    mediump float g1;
    mediump float c;
    
    g = col2.r;
    c = col1.r;
    g0 = g - 0.5;
    g1 = abs(g0);
    col3.r = g + (c - g - 2.0 * c * g1 + g0 + g1) * rat;
    
    g = col2.g;
    c = col1.g;
    g0 = g - 0.5;
    g1 = abs(g0);
    col3.g = g + (c - g - 2.0 * c * g1 + g0 + g1) * rat;
    
    g = col2.b;
    c = col1.b;
    g0 = g - 0.5;
    g1 = abs(g0);
    col3.b = g + (c - g - 2.0 * c * g1 + g0 + g1) * rat;
    
    
    gl_FragColor = col3;
    
}
