//
//  Shader.fsh
//  gltest00
//
//  Created by Nakahashi Teruyuki on 13/02/15.
//

varying highp vec2 v_texCoord;
varying highp vec4 v_position;


/*
varying highp vec4 v_color;
*/
varying mediump vec4 v_color;


/*
uniform sampler2D renderframe;
uniform sampler2D renderframe2;
uniform sampler2D renderframe3;
 */
uniform lowp sampler2D renderframe;
uniform lowp sampler2D renderframe2;
uniform lowp sampler2D renderframe3;

uniform int use_alpha;
uniform int use_color;

/*
uniform highp float alpha_value;
 */
uniform mediump float alpha_value;



void main()
{
    /*
    highp vec4 col1;
    highp vec4 col2;
    highp vec4 col3;
     */
    mediump vec4 col1;
    mediump vec4 col2;
    mediump vec4 col3;
    
    //lowp vec4 col1;
    
    
    col1 = texture2D(renderframe2, v_position.xy);
    col2 = texture2D(renderframe, v_texCoord);
    if (use_alpha != 0) {
        col2.a = col2.a * alpha_value;
    }
    if (use_color != 0) {
        col2 = col2 * v_color;
    }
    
////if (col2.a <= 0.0001) discard;
    
    col3 = col2;
    
    
    /*
    highp float rat = col1.a;
    highp float gray;
     */
    mediump float rat = col1.a;
    
    /*
    lowp float gray;
    gray = col1.r;
    if (gray >= 0.5) {
        col3.r = (1.0 - (1.0 - col2.r) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.r;
    } else {
        col3.r = (col2.r * 2.0 * gray) * rat + (1.0 - rat) * col2.r;
    }
    gray = col1.g;
    if (gray >= 0.5) {
        col3.g = (1.0 - (1.0 - col2.g) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.g;
    } else {
        col3.g = (col2.g * 2.0 * gray) * rat + (1.0 - rat) * col2.g;
    }
    gray = col1.b;
    if (gray >= 0.5) {
        col3.b = (1.0 - (1.0 - col2.b) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.b;
    } else {
        col3.b = (col2.b * 2.0 * gray) * rat + (1.0 - rat) * col2.b;
    }
    */
    
    /*
     40 FPS
    lowp float gray;
    gray = col1.r;
    if (gray >= 0.5) {
        col3.r = (1.0 - (1.0 - col2.r) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.r;
    } else {
        col3.r = (col2.r * 2.0 * gray) * rat + (1.0 - rat) * col2.r;
    }
    gray = col1.g;
    if (gray >= 0.5) {
        col3.g = (1.0 - (1.0 - col2.g) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.g;
    } else {
        col3.g = (col2.g * 2.0 * gray) * rat + (1.0 - rat) * col2.g;
    }
    gray = col1.b;
    if (gray >= 0.5) {
        col3.b = (1.0 - (1.0 - col2.b) * (1.0 - 2.0 * (gray - 0.5))) * rat + (1.0 - rat) * col2.b;
    } else {
        col3.b = (col2.b * 2.0 * gray) * rat + (1.0 - rat) * col2.b;
    }
     */
    
    
    /*
     36 FPS
     分岐を減らしたにも関わらずFPSが減った
    lowp float g;
    lowp float c;
    lowp float c1;

    
    g = col1.r;
    c = col2.r;
    c1 = 2.0 * c * (0.5 - abs(g - 0.5)) + g - 0.5 + abs(g - 0.5);
    col3.r = c1 * rat +  c * (1.0 - rat);
    
    g = col1.g;
    c = col2.g;
    c1 = 2.0 * c * (0.5 - abs(g - 0.5)) + g - 0.5 + abs(g - 0.5);
    col3.g = c1 * rat +  c * (1.0 - rat);
    
    g = col1.b;
    c = col2.b;
    c1 = 2.0 * c * (0.5 - abs(g - 0.5)) + g - 0.5 + abs(g - 0.5);
    col3.b = c1 * rat +  c * (1.0 - rat);
     */
    
    /*
     40 FPS -> 44 FPS
     lowp float g;
     lowp float ga;
     lowp float c;
     lowp float c1;
     
     g = col1.r - 0.5;
     ga = abs(g);
     c = col2.r;
     //col3.r = (2.0 * c * (0.5 - ga) + g + ga) * rat +  c * (1.0 - rat);
     col3.r = c * (1.0 - 2.0 * rat * ga) + rat * (g + ga);
     
     g = col1.g - 0.5;
     ga = abs(g);
     c = col2.g;
     col3.g = c * (1.0 - 2.0 * rat * ga) + rat * (g + ga);
     
     g = col1.b - 0.5;
     ga = abs(g);
     c = col2.b;
     col3.b = c * (1.0 - 2.0 * rat * ga) + rat * (g + ga);
     */
    
    
    /*
    // 40 FPS -> 48 FPS!
    lowp float g;
    lowp float ga;
    lowp float c;
    lowp float c1;
    
    g = col1.r - 0.5;
    ga = abs(g);
    c = col2.r;
    col3.r = (2.0 * c * (0.5 - ga) + g + ga) * rat +  c * (1.0 - rat);
    
    g = col1.g - 0.5;
    ga = abs(g);
    c = col2.g;
    col3.g = (2.0 * c * (0.5 - ga) + g + ga) * rat +  c * (1.0 - rat);
    
    g = col1.b - 0.5;
    ga = abs(g);
    c = col2.b;
    col3.b = (2.0 * c * (0.5 - ga) + g + ga) * rat +  c * (1.0 - rat);
    */

    
    // 40 FPS -> 58 FPS!
    
    mediump float g;
    mediump float ga;
    mediump float c;
    mediump float c1;
    
    g = col1.r - 0.5;
    ga = abs(g);
    c = col2.r;
    col3.r = (c * (- ga - ga) + g + ga) * rat +  c;
    
    g = col1.g - 0.5;
    ga = abs(g);
    c = col2.g;
    col3.g = (c * (- ga - ga) + g + ga) * rat +  c;
    
    g = col1.b - 0.5;
    ga = abs(g);
    c = col2.b;
    col3.b = (c * (- ga - ga) + g + ga) * rat +  c;

    
    
    
    
    
    
    
    
    
    mediump vec4 col5;
    mediump float x, y;
    mediump float trat = 256.0 / 320.0;
    
    y = 0.0;
    x = col3.r * trat;
    
    col5 = texture2D(renderframe3, vec2(x, y));
    col3.r = col5.r;
     
    ////col5.r = texture2D(renderframe3, vec2(x, y));
    
    
    x = col3.g * trat;
    
    col5 = texture2D(renderframe3, vec2(x, y));
    col3.g = col5.g;
     
    ////col5.g = texture2D(renderframe3, vec2(x, y));
    
    
    x = col3.b * trat;
    
    col5 = texture2D(renderframe3, vec2(x, y));
    col3.b = col5.b;
     
    ////col5.b = texture2D(renderframe3, vec2(x, y));
   
    
    
    
    
    gl_FragColor = col3;
     
    ////gl_FragColor = col5;
    
}
