//
//  Shader.fsh
//  gltest00
//
//  Created by Nakahashi Teruyuki on 13/02/15.
//

varying highp vec2 v_texCoord;
//varying lowp vec2 v_texCoord;
varying highp vec4 v_color;
//varying lowp vec4 v_color;

uniform sampler2D renderframe;
uniform int use_alpha;
uniform int use_color;
uniform highp float alpha_value;
//uniform lowp float alpha_value;
//uniform highp float color_table_r[256];
//uniform highp float color_table_g[256];
//uniform highp float color_table_b[256];

//uniform highp float tc_offset[2];
varying highp vec2 v_tc00;
varying highp vec2 v_tc01;
varying highp vec2 v_tc02;
varying highp vec2 v_tc10;
varying highp vec2 v_tc11;
varying highp vec2 v_tc12;
varying highp vec2 v_tc20;
varying highp vec2 v_tc21;
varying highp vec2 v_tc22;


void main()
{
    
    highp vec4 col1;
    //lowp vec4 col1;
    
    highp vec4 sample[9];
    //highp float dx = tc_offset[0];
    //highp float dy = tc_offset[1];
    highp float dx = 1.0 / 512.0;
    highp float dy = 1.0 / 512.0;
    sample[0] = texture2D(renderframe, v_tc00);
    sample[1] = texture2D(renderframe, v_tc01);
    sample[2] = texture2D(renderframe, v_tc02);
    sample[3] = texture2D(renderframe, v_tc10);
    //sample[4] = texture2D(renderframe, v_texCoord + vec2(0.0, 0.0));
    sample[5] = texture2D(renderframe, v_tc12);
    sample[6] = texture2D(renderframe, v_tc20);
    sample[7] = texture2D(renderframe, v_tc21);
    sample[8] = texture2D(renderframe, v_tc22);
    
    col1 = texture2D(renderframe, v_texCoord);
    
    highp vec4 horizEdge = sample[2] + (2.0 * sample[5]) + sample[8] - (sample[0] + (2.0 * sample[3]) + sample[6]);
    highp vec4 vertEdge  = sample[0] + (2.0 * sample[1]) + sample[2] - (sample[6] + (2.0 * sample[7]) + sample[8]);
    
    //col1.rgb = abs(horizEdge.rgb);
    col1.rgb = sqrt((horizEdge.rgb * horizEdge.rgb) + (vertEdge.rgb * vertEdge.rgb));
    //col1.rgb = sample[0].rgb;
    
    if (use_alpha != 0) {

        col1.a = col1.a * alpha_value;
        
    }
    
    if (use_color != 0) {
        col1 = col1 * v_color;
    }
    
    //col1.r = col1.r * 0.7;
    //col1.b = col1.b * 0.7;
    //col1.g = col1.g * 0.87;
    
    gl_FragColor = col1;

}
